import $$observable from 'symbol-observable';
import { Observable } from 'rxjs/Observable';
import { filter } from 'rxjs/operator/filter';
import { WheelEventEmulatorOperator } from '../operators/WheelEventEmulatorOperator';
import { createEventSourcePool } from '../events/createEventSourcePool';
import { WHEEL } from '../events';

const eventSourcePool = createEventSourcePool(WheelEventEmulatorOperator);

export class EmulatedWheelEventObservable extends Observable {
  constructor(target, eventType, predicate) {
    if (typeof target[$$observable] === 'function') {
      super();
      this.source = target[$$observable]();
    } else {
      var _context;

      super();
      this.source = (_context = eventSourcePool(target, eventType, WHEEL), filter).call(_context, ({ type }) => type === eventType);

      if (predicate) {
        var _context2;

        this.source = (_context2 = this.source, filter).call(_context2, predicate);
      }
    }
  }

  lift(operator) {
    const observable = new EmulatedWheelEventObservable(this);
    observable.operator = operator;
    return observable;
  }

  static create(...args) {
    return new EmulatedWheelEventObservable(...args);
  }
}

export default EmulatedWheelEventObservable;