'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Touch = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _symbolObservable = require('symbol-observable');

var _symbolObservable2 = _interopRequireDefault(_symbolObservable);

var _takeUntil = require('rxjs/operator/takeUntil');

var _skipWhile = require('rxjs/operator/skipWhile');

var _take = require('rxjs/operator/take');

var _timer = require('rxjs/observable/timer');

var _race = require('rxjs/operator/race');

var _merge = require('rxjs/operator/merge');

var _mergeMap = require('rxjs/operator/mergeMap');

var _DeltaOperator = require('./operators/DeltaOperator');

var _DeltaObservable2 = require('./observables/DeltaObservable');

var _EmulatedTouchEventObservable = require('./observables/EmulatedTouchEventObservable');

var _utils = require('./utils');

var _events = require('./events');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var excludeMultiTouch = function excludeMultiTouch(e) {
  return e.touches.length <= 1;
};

var Touch = exports.Touch = function (_DeltaObservable) {
  _inherits(Touch, _DeltaObservable);

  function Touch(target) {
    var event = arguments.length <= 1 || arguments[1] === undefined ? _events.TOUCH_MOVE : arguments[1];

    _classCallCheck(this, Touch);

    if (typeof target[_symbolObservable2.default] === 'function') {
      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Touch).call(this, target));
    } else {
      var source = _EmulatedTouchEventObservable.EmulatedTouchEventObservable.create(target, event, excludeMultiTouch);
      source.operator = new _DeltaOperator.DeltaOperator(computeTouchDelta, computeTouchVelocity, snapshotTouchEvent);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Touch).call(this, source));
    }
    return _possibleConstructorReturn(_this);
  }

  _createClass(Touch, null, [{
    key: 'scrollStart',
    value: function scrollStart(target) {
      var _context,
          _this2 = this;

      var radius = arguments.length <= 1 || arguments[1] === undefined ? { w: 10, h: 10 } : arguments[1];
      var delay = arguments.length <= 2 || arguments[2] === undefined ? 300 : arguments[2];

      var scrollCancel = this.scrollStop(target);
      if (delay > 0) scrollCancel = (0, _race.raceStatic)((0, _timer.timer)(delay), scrollCancel);
      return (_context = _get(Object.getPrototypeOf(Touch), 'scrollStart', this).call(this, target, _events.TOUCH_START), _mergeMap.mergeMap).call(_context, function (offset) {
        var _context2;

        return (_context2 = (_context2 = (_context2 = _get(Object.getPrototypeOf(Touch), 'from', _this2).call(_this2, target).hijack().accumulate(), _takeUntil.takeUntil).call(_context2, scrollCancel), _skipWhile.skipWhile).call(_context2, function (netValue) {
          return (0, _utils.inside)(radius.w, radius.h, netValue.deltaX, netValue.deltaY);
        }), _take.take).call(_context2, 1);
      });
    }
  }, {
    key: 'scrollStop',
    value: function scrollStop(target) {
      return new this((0, _merge.mergeStatic)(_get(Object.getPrototypeOf(Touch), 'scrollStop', this).call(this, target, _events.TOUCH_END), _get(Object.getPrototypeOf(Touch), 'scrollStop', this).call(this, target, _events.TOUCH_CANCEL)));
    }
  }]);

  return Touch;
}(_DeltaObservable2.DeltaObservable);

exports.default = Touch;


var computeTouchDelta = function computeTouchDelta(event, lastEvent) {
  var deltaX = 0;
  var deltaY = 0;
  var hasATouch = event && event.touches && event.touches.length;
  var hadATouch = lastEvent && lastEvent.touches && lastEvent.touches.length;
  if (hasATouch && hadATouch) {
    var _lastEvent$touches$ = lastEvent.touches[0];
    var prevX = _lastEvent$touches$.clientX;
    var prevY = _lastEvent$touches$.clientY;
    var _event$touches$ = event.touches[0];
    var clientX = _event$touches$.clientX;
    var clientY = _event$touches$.clientY;

    deltaX = prevX - clientX;
    deltaY = prevY - clientY;
  }
  return { deltaX: deltaX, deltaY: deltaY };
};

var computeTouchVelocity = function computeTouchVelocity(event, lastEvent, deltaT) {
  var velocityX = 0;
  var velocityY = 0;
  var hasATouch = event && event.touches && event.touches.length;
  var hadATouch = lastEvent && lastEvent.touches && lastEvent.touches.length;
  if (deltaT && hasATouch && hadATouch) {
    var t = deltaT / 1000;
    var _lastEvent$touches$2 = lastEvent.touches[0];
    var prevX = _lastEvent$touches$2.clientX;
    var prevY = _lastEvent$touches$2.clientY;
    var _event$touches$2 = event.touches[0];
    var clientX = _event$touches$2.clientX;
    var clientY = _event$touches$2.clientY;

    velocityX = (prevX - clientX) / t;
    velocityY = (prevY - clientY) / t;
  }
  return { velocityX: velocityX, velocityY: velocityY };
};

var snapshotTouchEvent = function snapshotTouchEvent(event) {
  var touches = [];
  for (var i = 0; i < event.touches.length; i++) {
    var _event$touches$i = event.touches[i];
    var clientX = _event$touches$i.clientX;
    var clientY = _event$touches$i.clientY;

    touches.push({ clientX: clientX, clientY: clientY });
  }
  return { touches: touches };
};