'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Wheel = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _symbolObservable = require('symbol-observable');

var _symbolObservable2 = _interopRequireDefault(_symbolObservable);

var _DeltaObservable2 = require('./observables/DeltaObservable');

var _DeltaOperator = require('./operators/DeltaOperator');

var _EmulatedWheelEventObservable = require('./observables/EmulatedWheelEventObservable');

var _events = require('./events');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wheel = exports.Wheel = function (_DeltaObservable) {
  _inherits(Wheel, _DeltaObservable);

  function Wheel(target) {
    var event = arguments.length <= 1 || arguments[1] === undefined ? _events.WHEEL_MOVE : arguments[1];

    _classCallCheck(this, Wheel);

    if (typeof target[_symbolObservable2.default] === 'function') {
      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Wheel).call(this, target));
    } else {
      var source = _EmulatedWheelEventObservable.EmulatedWheelEventObservable.create(target, event);
      source.operator = new _DeltaOperator.DeltaOperator();

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Wheel).call(this, source));
    }
    return _possibleConstructorReturn(_this);
  }

  _createClass(Wheel, null, [{
    key: 'scrollStart',
    value: function scrollStart(target) {
      return _get(Object.getPrototypeOf(Wheel), 'scrollStart', this).call(this, target, _events.WHEEL_START);
    }
  }, {
    key: 'scrollStop',
    value: function scrollStop(target) {
      return _get(Object.getPrototypeOf(Wheel), 'scrollStop', this).call(this, target, _events.WHEEL_END);
    }
  }]);

  return Wheel;
}(_DeltaObservable2.DeltaObservable);

exports.default = Wheel;