'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EmulatedKeyboardEventObservable = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _symbolObservable = require('symbol-observable');

var _symbolObservable2 = _interopRequireDefault(_symbolObservable);

var _Observable2 = require('rxjs/Observable');

var _filter = require('rxjs/operator/filter');

var _KeyboardEventEmulatorOperator = require('../operators/KeyboardEventEmulatorOperator');

var _createEventSourcePool = require('../events/createEventSourcePool');

var _events = require('../events');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Map synthetic keyboard events to real ones.
var getRealEventType = function getRealEventType(eventType) {
  switch (eventType) {
    case _events.KEY_UP:
    case _events.KEY_END:
      return _events.KEY_UP;
    default:
      return _events.KEY_DOWN;
  }
};

var eventSourcePool = (0, _createEventSourcePool.createEventSourcePool)(_KeyboardEventEmulatorOperator.KeyboardEventEmulatorOperator);

var EmulatedKeyboardEventObservable = exports.EmulatedKeyboardEventObservable = function (_Observable) {
  _inherits(EmulatedKeyboardEventObservable, _Observable);

  function EmulatedKeyboardEventObservable(target, eventType, predicate) {
    _classCallCheck(this, EmulatedKeyboardEventObservable);

    if (typeof target[_symbolObservable2.default] === 'function') {
      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(EmulatedKeyboardEventObservable).call(this));

      _this.source = target[_symbolObservable2.default]();
    } else {
      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(EmulatedKeyboardEventObservable).call(this));

      _this.source = eventSourcePool.get(target, eventType, getRealEventType(eventType));

      if (predicate) {
        var _context;

        _this.source = (_context = _this.source, _filter.filter).call(_context, predicate);
      }
    }
    return _possibleConstructorReturn(_this);
  }

  _createClass(EmulatedKeyboardEventObservable, [{
    key: 'lift',
    value: function lift(operator) {
      var observable = new EmulatedKeyboardEventObservable(this);
      observable.operator = operator;
      return observable;
    }
  }], [{
    key: 'create',
    value: function create() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return new (Function.prototype.bind.apply(EmulatedKeyboardEventObservable, [null].concat(args)))();
    }
  }]);

  return EmulatedKeyboardEventObservable;
}(_Observable2.Observable);

exports.default = EmulatedKeyboardEventObservable;