'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DeltaOperator = exports.DeltaSubscriber = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Subscriber2 = require('rxjs/Subscriber');

var _utils = require('../utils');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DeltaSubscriber = exports.DeltaSubscriber = function (_Subscriber) {
  _inherits(DeltaSubscriber, _Subscriber);

  function DeltaSubscriber(destination, computeDelta, computeVelocity, snapshotEvent) {
    _classCallCheck(this, DeltaSubscriber);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(DeltaSubscriber).call(this, destination));

    _this.computeDelta = computeDelta || DeltaSubscriber._computeDelta;
    _this.computeVelocity = computeVelocity || DeltaSubscriber._computeVelocity;
    _this.snapshotEvent = snapshotEvent || DeltaSubscriber._snapshotEvent;
    _this._lastEvent = null;
    _this._lastTime = null;
    return _this;
  }

  _createClass(DeltaSubscriber, [{
    key: '_next',
    value: function _next(event) {
      var lastEvent = this._lastEvent;
      var lastTime = this._lastTime;

      var time = (0, _utils.timeStamp)(event);
      var deltaT = lastTime ? time - lastTime : 0;
      var delta = this.computeDelta(event, lastEvent, deltaT);
      var velocity = this.computeVelocity(event, lastEvent, deltaT);

      this._lastEvent = this.snapshotEvent(event);
      this._lastTime = time;

      _get(Object.getPrototypeOf(DeltaSubscriber.prototype), '_next', this).call(this, _extends({}, delta, velocity, { deltaT: deltaT, event: event }));
    }
  }, {
    key: '_complete',
    value: function _complete() {
      this._lastEvent = null;
      this._lastTime = null;
      _get(Object.getPrototypeOf(DeltaSubscriber.prototype), '_complete', this).call(this);
    }
  }], [{
    key: '_computeVelocity',
    value: function _computeVelocity(event, lastEvent, deltaT) {
      var velocityX = event.velocityX;
      var velocityY = event.velocityY;
      var deltaX = event.deltaX;
      var deltaY = event.deltaY;


      if (velocityX == null && velocityY == null) {
        velocityX = 0;
        velocityY = 0;

        if (deltaT && deltaX != null && deltaY != null) {
          var t = deltaT / 1000;
          velocityX = deltaX / t;
          velocityY = deltaY / t;
        }
      }

      return { velocityX: velocityX, velocityY: velocityY };
    }
  }, {
    key: '_computeDelta',
    value: function _computeDelta(event, lastEvent) {
      var deltaX = event.deltaX;
      var deltaY = event.deltaY;

      return { deltaX: deltaX, deltaY: deltaY };
    }
  }, {
    key: '_snapshotEvent',
    value: function _snapshotEvent(event) {
      return event;
    }
  }]);

  return DeltaSubscriber;
}(_Subscriber2.Subscriber);

var DeltaOperator = exports.DeltaOperator = function () {
  function DeltaOperator(computeDelta, computeVelocity, snapshotEvent) {
    _classCallCheck(this, DeltaOperator);

    this.computeDelta = computeDelta;
    this.computeVelocity = computeVelocity;
    this.snapshotEvent = snapshotEvent;
  }

  _createClass(DeltaOperator, [{
    key: 'call',
    value: function call(subscriber, source) {
      return source._subscribe(new DeltaSubscriber(subscriber, this.computeDelta, this.computeVelocity, this.snapshotEvent));
    }
  }]);

  return DeltaOperator;
}();

exports.default = DeltaOperator;