'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KeyboardEventEmulatorOperator = undefined;

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Subscriber2 = require('rxjs/Subscriber');

var _events = require('../events');

var _EmulatedKeyboardEvent = require('../events/EmulatedKeyboardEvent');

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var KeyboardEventEmulatorOperator = exports.KeyboardEventEmulatorOperator = function () {
  function KeyboardEventEmulatorOperator() {
    _classCallCheck(this, KeyboardEventEmulatorOperator);
  }

  _createClass(KeyboardEventEmulatorOperator, [{
    key: 'call',
    value: function call(subscriber, source) {
      return source._subscribe(new KeyboardEventEmulatorSubcriber(subscriber));
    }
  }]);

  return KeyboardEventEmulatorOperator;
}();

exports.default = KeyboardEventEmulatorOperator;

var KeyboardEventEmulatorSubcriber = function (_Subscriber) {
  _inherits(KeyboardEventEmulatorSubcriber, _Subscriber);

  function KeyboardEventEmulatorSubcriber(destination) {
    _classCallCheck(this, KeyboardEventEmulatorSubcriber);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(KeyboardEventEmulatorSubcriber).call(this, destination));

    _this._started = false;
    _this._lastValue;
    return _this;
  }

  _createClass(KeyboardEventEmulatorSubcriber, [{
    key: '_next',
    value: function _next(value) {
      if (!this._started && value.type === _events.KEY_DOWN) {
        this._lastValue = value;
        this.startNow();
        this.moveNow();
      } else if (this.isRepeat(value)) {
        this._lastValue = value;
        this.moveNow();
      } else {
        this.stopNow();

        if (value.type === _events.KEY_DOWN) {
          this._lastValue = value;
          this.startNow();
        }
      }
    }
  }, {
    key: '_complete',
    value: function _complete() {
      _get(Object.getPrototypeOf(KeyboardEventEmulatorSubcriber.prototype), '_complete', this).call(this);
      this._started = false;
      this._lastValue = null;
    }
  }, {
    key: 'isRepeat',
    value: function isRepeat(value) {
      var isit = value && this._lastValue && value.type === this._lastValue.type && value.key === this._lastValue.key && value.code === this._lastValue.code && value.ctrlKey === this._lastValue.ctrlKey && value.shiftKey === this._lastValue.shiftKey && value.altKey === this._lastValue.altKey && value.metaKey === this._lastValue.metaKey;
      return isit;
    }
  }, {
    key: 'startNow',
    value: function startNow() {
      if (!this._started) {
        this._started = true;
        this.dispatch(new _EmulatedKeyboardEvent.EmulatedKeyboardEvent(this._lastValue, _events.KEY_START));
      }
    }
  }, {
    key: 'moveNow',
    value: function moveNow() {
      this.dispatch(new _EmulatedKeyboardEvent.EmulatedKeyboardEvent(this._lastValue, _events.KEY_MOVE));
    }
  }, {
    key: 'stopNow',
    value: function stopNow() {
      if (this._started) {
        this._started = false;
        this.dispatch(new _EmulatedKeyboardEvent.EmulatedKeyboardEvent(this._lastValue, _events.KEY_END));
      }
    }
  }, {
    key: 'dispatch',
    value: function dispatch(value) {
      _get(Object.getPrototypeOf(KeyboardEventEmulatorSubcriber.prototype), '_next', this).call(this, value);
    }
  }]);

  return KeyboardEventEmulatorSubcriber;
}(_Subscriber2.Subscriber);