'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WheelEventEmulatorOperator = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Subscriber2 = require('rxjs/Subscriber');

var _async = require('rxjs/scheduler/async');

var _events = require('../events');

var _EmulatedWheelEvent = require('../events/EmulatedWheelEvent');

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SCROLL_STOP_DELAY = 60;

var dispatchStop = function dispatchStop(subscriber) {
  subscriber.stopNow();
};

var WheelEventEmulatorOperator = exports.WheelEventEmulatorOperator = function () {
  function WheelEventEmulatorOperator() {
    _classCallCheck(this, WheelEventEmulatorOperator);
  }

  _createClass(WheelEventEmulatorOperator, [{
    key: 'call',
    value: function call(subscriber, source) {
      return source._subscribe(new WheelEventEmulatorSubcriber(subscriber));
    }
  }]);

  return WheelEventEmulatorOperator;
}();

exports.default = WheelEventEmulatorOperator;

var WheelEventEmulatorSubcriber = function (_Subscriber) {
  _inherits(WheelEventEmulatorSubcriber, _Subscriber);

  function WheelEventEmulatorSubcriber(destination) {
    _classCallCheck(this, WheelEventEmulatorSubcriber);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(WheelEventEmulatorSubcriber).call(this, destination));

    _this._started = false;
    _this._lastValue;
    return _this;
  }

  _createClass(WheelEventEmulatorSubcriber, [{
    key: '_next',
    value: function _next(value) {
      this._lastValue = value;

      if (!this._started) {
        this.startNow();
        this.moveNow();
      } else {
        this.moveNow();
        this.scheduleStop();
      }
    }
  }, {
    key: '_complete',
    value: function _complete() {
      _get(Object.getPrototypeOf(WheelEventEmulatorSubcriber.prototype), '_complete', this).call(this);
      this.cancelStop();
      this._started = false;
      this._lastValue = null;
    }
  }, {
    key: 'cancelStop',
    value: function cancelStop() {
      if (this._scheduled) {
        this.remove(this._scheduled);
        this._scheduled.unsubscribe();
        this._scheduled = null;
      }
    }
  }, {
    key: 'scheduleStop',
    value: function scheduleStop() {
      this.cancelStop();
      this._scheduled = _async.async.schedule(dispatchStop, SCROLL_STOP_DELAY, this);
      this.add(this._scheduled);
    }
  }, {
    key: 'startNow',
    value: function startNow() {
      if (!this._started) {
        this._started = true;
        var value = _extends({}, this._lastValue, { deltaX: 0, deltaY: 0 });
        this.dispatch(new _EmulatedWheelEvent.EmulatedWheelEvent(value, _events.WHEEL_START));
      }
    }
  }, {
    key: 'moveNow',
    value: function moveNow() {
      this.dispatch(new _EmulatedWheelEvent.EmulatedWheelEvent(this._lastValue, _events.WHEEL_MOVE));
    }
  }, {
    key: 'stopNow',
    value: function stopNow() {
      this.cancelStop();
      if (this._started) {
        this._started = false;
        var value = _extends({}, this._lastValue, { deltaX: 0, deltaY: 0 });
        this.dispatch(new _EmulatedWheelEvent.EmulatedWheelEvent(value, _events.WHEEL_MOVE));
        this.dispatch(new _EmulatedWheelEvent.EmulatedWheelEvent(value, _events.WHEEL_END));
      }
    }
  }, {
    key: 'dispatch',
    value: function dispatch(value) {
      _get(Object.getPrototypeOf(WheelEventEmulatorSubcriber.prototype), '_next', this).call(this, value);
    }
  }]);

  return WheelEventEmulatorSubcriber;
}(_Subscriber2.Subscriber);