"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * The base Updater class.
 * Doesn't really *do* anything on its own,
 * but subclasses can extend the underscored methods to
 * 'hook' into the update lifecycle.
 */

var Updater = exports.Updater = function () {
  function Updater() {
    _classCallCheck(this, Updater);

    this.stopped = true;
    this.init.apply(this, arguments);
  }

  _createClass(Updater, [{
    key: "init",
    value: function init() {
      this._init.apply(this, arguments);
    }
  }, {
    key: "clone",
    value: function clone() {
      var updater = new this.constructor();
      updater.stopped = this.stopped;
      return this._clone(updater);
    }
  }, {
    key: "start",
    value: function start() {
      this.stopped = false;
      this._start();
      return this.stopped === false;
    }
  }, {
    key: "stop",
    value: function stop() {
      this.stopped = true;
      this._stop();
      return this.stopped === true;
    }
  }, {
    key: "computeNext",
    value: function computeNext(value) {
      return this._computeNext(value);
    }
  }, {
    key: "shouldGenerateNext",
    value: function shouldGenerateNext() {
      return this._shouldGenerateNext();
    }
  }, {
    key: "updateFrame",
    value: function updateFrame(value) {
      this._updateFrame(value);
    }
  }, {
    key: "catchFrame",
    value: function catchFrame(value) {
      this._catchFrame(value);
    }
  }, {
    key: "_init",
    value: function _init() {/* noop */}
  }, {
    key: "_clone",
    value: function _clone(target) {
      return target;
    }
  }, {
    key: "_start",
    value: function _start() {/* noop */}
  }, {
    key: "_stop",
    value: function _stop() {/* noop */}
  }, {
    key: "_computeNext",
    value: function _computeNext(value) {
      return value;
    }
  }, {
    key: "_shouldGenerateNext",
    value: function _shouldGenerateNext() {
      return false;
    }
  }, {
    key: "_updateFrame",
    value: function _updateFrame(value) {/* noop */}
  }, {
    key: "_catchFrame",
    value: function _catchFrame(value) {/* noop */}
  }]);

  return Updater;
}();

exports.default = Updater;