'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.anchor = exports.anchorY = exports.anchorX = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _KinematicUpdater2 = require('./KinematicUpdater');

var _computeNextValue3 = require('./computeNextValue');

var _parseOpts = require('./parseOpts');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var F = 1000 / 60; // Default frame rate

var AnchorUpdater = function (_KinematicUpdater) {
  _inherits(AnchorUpdater, _KinematicUpdater);

  function AnchorUpdater() {
    _classCallCheck(this, AnchorUpdater);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(AnchorUpdater).apply(this, arguments));
  }

  _createClass(AnchorUpdater, [{
    key: '_initSpring',
    value: function _initSpring(spring) {
      spring.velocity = 0;
      spring.netDelta = 0;
    }
  }, {
    key: '_updateFrameSpring',
    value: function _updateFrameSpring(value, spring) {
      spring.netDelta += spring.toDelta(value);
      spring.velocity = spring.toVelocity(value);
    }
  }, {
    key: '_computeNextSpring',
    value: function _computeNextSpring(value, spring) {
      var stopped = this.stopped;
      var netDelta = spring.netDelta;
      var velocity = spring.velocity;
      var K = spring.stiffness;
      var B = spring.damping;
      var P = spring.precision;

      // If we're not stopped, add velocity from input
      // to the residual velocity from the last update.

      if (!stopped) {
        velocity = 0.2 * velocity + 0.8 * spring.toVelocity(value);
      }

      var t = Math.min(F, Math.max(value.deltaT || 1)) / 1000;

      // Compute the result of the current frame.

      var _computeNextValue = (0, _computeNextValue3.computeNextValue)(netDelta, 0, velocity, t, K, B, P);

      var _computeNextValue2 = _slicedToArray(_computeNextValue, 2);

      var newNetDelta = _computeNextValue2[0];
      var newVelocity = _computeNextValue2[1];

      var newDelta = newNetDelta - netDelta;

      return _extends({}, value, spring.fromDelta(newDelta), spring.fromVelocity(newVelocity));
    }
  }, {
    key: '_shouldGenerateNextSpring',
    value: function _shouldGenerateNextSpring(spring) {
      return spring.velocity !== 0 || spring.netDelta !== 0;
    }
  }]);

  return AnchorUpdater;
}(_KinematicUpdater2.KinematicUpdater);

var anchorX = exports.anchorX = function anchorX(opts) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return new (Function.prototype.bind.apply(AnchorUpdater, [null].concat([[(0, _parseOpts.parseXOpts)(opts)]], args)))();
};

var anchorY = exports.anchorY = function anchorY(opts) {
  for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }

  return new (Function.prototype.bind.apply(AnchorUpdater, [null].concat([[(0, _parseOpts.parseYOpts)(opts)]], args)))();
};

var anchor = exports.anchor = function anchor(opts) {
  for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
    args[_key3 - 1] = arguments[_key3];
  }

  return new (Function.prototype.bind.apply(AnchorUpdater, [null].concat([[(0, _parseOpts.parseXOpts)(opts), (0, _parseOpts.parseYOpts)(opts)]], args)))();
};

anchor.x = anchorX;
anchor.y = anchorY;

exports.default = anchor;