'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rect = exports.rectY = exports.rectX = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _KinematicUpdater2 = require('./KinematicUpdater');

var _parseOpts = require('./parseOpts');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RectUpdater = function (_KinematicUpdater) {
  _inherits(RectUpdater, _KinematicUpdater);

  function RectUpdater() {
    _classCallCheck(this, RectUpdater);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(RectUpdater).apply(this, arguments));
  }

  _createClass(RectUpdater, [{
    key: '_initSpring',
    value: function _initSpring(spring, opts) {
      spring.netDelta = 0;
      spring.minNetDelta = spring.minNetDelta || 0;
      spring.maxNetDelta = spring.maxNetDelta || 0;
    }
  }, {
    key: '_updateFrameSpring',
    value: function _updateFrameSpring(value, spring) {
      spring.netDelta += spring.toDelta(value);
    }
  }, {
    key: '_computeNextSpring',
    value: function _computeNextSpring(value, spring) {
      var newDelta = spring.toDelta(value);
      var netDelta = spring.netDelta;
      var minNetDelta = spring.minNetDelta;
      var maxNetDelta = spring.maxNetDelta;

      var newNetDelta = netDelta + newDelta;

      var outOfBounds = false;

      if (newNetDelta < minNetDelta) {
        outOfBounds = true;
        newDelta -= newNetDelta - minNetDelta;
      } else if (newNetDelta > maxNetDelta) {
        outOfBounds = true;
        newDelta -= newNetDelta - maxNetDelta;
      }

      if (!outOfBounds) return value;

      var v = _extends({}, value, spring.fromDelta(newDelta));

      return v;
    }
  }, {
    key: '_shouldGenerateNextSpring',
    value: function _shouldGenerateNextSpring(spring) {
      return spring.netDelta > spring.maxNetDelta || spring.netDelta < spring.minNetDelta;
    }
  }]);

  return RectUpdater;
}(_KinematicUpdater2.KinematicUpdater);

var rectX = exports.rectX = function rectX(opts) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return new (Function.prototype.bind.apply(RectUpdater, [null].concat([[(0, _parseOpts.parseXOpts)(opts)]], args)))();
};

var rectY = exports.rectY = function rectY(opts) {
  for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }

  return new (Function.prototype.bind.apply(RectUpdater, [null].concat([[(0, _parseOpts.parseYOpts)(opts)]], args)))();
};

var rect = exports.rect = function rect(opts) {
  for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
    args[_key3 - 1] = arguments[_key3];
  }

  return new (Function.prototype.bind.apply(RectUpdater, [null].concat([[(0, _parseOpts.parseXOpts)(opts), (0, _parseOpts.parseYOpts)(opts)]], args)))();
};

rect.x = rectX;
rect.y = rectY;

exports.default = rect;