'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var timeStamp = exports.timeStamp = function timeStamp(e) {
  return e.timeStamp ? parseInt(e.timeStamp, 10) : Date.now();
};

var getRoot = exports.getRoot = function getRoot() {
  return typeof window === 'undefined' ? typeof document === 'undefined' ? global : document : window;
};

var inside = exports.inside = function inside(w, h, dx, dy) {
  return w * h > Math.pow(dx, 2) + Math.pow(dy, 2);
};
var outside = exports.outside = function outside(w, h, dx, dy) {
  return w * h < Math.pow(dx, 2) + Math.pow(dy, 2);
};

var hasDelta = exports.hasDelta = function hasDelta(value) {
  return Boolean(value && (value.deltaT || value.deltaX || value.deltaY));
};

var isDeltaLike = exports.isDeltaLike = function isDeltaLike(value) {
  return Boolean(value && (value.deltaT != null || value.deltaX != null || value.deltaY != null));
};